spolynom = method()
spolynom (RingElement,RingElement) := RingElement => (f,g) -> (
   t:=gcd(leadMonomial(g),leadMonomial(f));
   return (leadTerm(g)//t)*f-(leadTerm(f)//t)*g;
);

normalForm = method ()
normalForm (List,RingElement) := RingElement =>  (G,f) -> (

r:=#G; --Anzahl der Polynome
f':=f; --Initialisierung

M:=flatten for t in terme(f') list for i in 0..(r-1) list if t//leadMonomial(G_i)!=0 then {t,i} else continue;

while #M>0 do (
   mm:=waehleMaximum(M); --wähle Maximum
   t:=mm_0;
   i:=mm_1;
   f'=f'-(t//leadTerm(G_i))*G_i;
    
   M=flatten for t in terme(f') list for i in 0..(r-1) list if t//leadMonomial(G_i)!=0 then {t,i} else continue;
    );

return f';

);

monome = method ()
monome (RingElement) := List => (f) -> (
   return flatten entries monomials(f);
);

terme = method ()
terme (RingElement) := List => (f) -> (
   return terms(f); 
);

waehleMaximum = method ()
waehleMaximum (List) := List => (M) -> (
m':=max(flatten for m in M list m_0);
pos:=position(M,m-> m_0==m');
return M_pos;
);
